<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="客户姓名" prop="customerName">
        <el-input
          v-model="queryParams.customerName"
          placeholder="请输入客户姓名"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="联系方式" prop="contact">
        <el-input
          v-model="queryParams.contact"
          placeholder="请输入联系方式"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="公司名称" prop="companyName">
        <el-input
          v-model="queryParams.companyName"
          placeholder="请输入公司名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="性质等级" prop="customerType">
        <el-select
          v-model="queryParams.customerType"
          placeholder="请选择性质等级"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.CUSTOMER_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['visit:customer-info:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['visit:customer-info:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true" @selection-change="handleSelectionChange">
      <el-table-column type="selection"  width="55" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="客户姓名" align="center" prop="customerName"  min-width="100px"/>
      <el-table-column label="联系方式" align="center" prop="contact"  min-width="120px"/>
      <el-table-column label="公司名称" align="center" prop="companyName"  min-width="160px"/>
      <el-table-column label="性质等级" align="center" prop="customerType">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_TYPE" :value="scope.row.customerType" />
        </template>
      </el-table-column>
      <el-table-column label="所在地区" align="center" prop="regionFullName" min-width="160px"/>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="产品信息" prop="productIds"  min-width="100px">
        <template #default="scope">
          <ProductList :ids=scope.row.productIds />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" min-width="320px" fixed="right">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="visitInfo(scope.row.companyName)"
          >
            拜访记录
          </el-button>
          <el-button
            link
            type="primary"
            @click="handlePrint(scope.row.companyName)"
          >
            打印拜访记录
          </el-button>
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['visit:customer-info:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['visit:customer-info:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <CustomerInfoForm ref="formRef" @success="getList" />
  <!-- 打印弹窗 -->
  <VisitPrint ref="visitPrintRef" :data="selectedData" />
</template>

<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { CustomerInfoApi, CustomerInfoVO } from '@/api/visit/customerinfo'
import CustomerInfoForm from './CustomerInfoForm.vue'
import ProductList from "@/views/visit/util/ProductList.vue";
import { useRouter } from 'vue-router'
import {InfoApi, InfoPrintVO} from "@/api/visit/info";


/** 客户信息 列表 */
defineOptions({ name: 'CustomerInfo' })
const router = useRouter()
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<CustomerInfoVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  customerName: undefined,
  contact: undefined,
  companyName: undefined,
  customerType: undefined,
  cityCode: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const multipleSelection = ref([])  //存储多选内容

const visitPrintRef = ref()

// 模拟获取详情数据的方法（你应该调 InfoApi.getInfoListByIds 或类似接口）
const selectedData = ref<InfoPrintVO[]>([])

const handlePrint = async (companyName: string) => {
  selectedData.value = await InfoApi.getPrintListByCompanyName(companyName)
  //判断是否有数据
  if (!selectedData.value) {
    message.warning('该客户暂无拜访记录')
    return
  }
  console.log(selectedData.value)
  await nextTick()
  visitPrintRef.value?.print()
}

/** 多选操作**/
const handleSelectionChange = (val) => {
  multipleSelection.value = val.map(item=>item.id)
  //console.log(val,multipleSelection)
}

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await CustomerInfoApi.getCustomerInfoPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}
const visitInfo=(data)=>{
  router.push({ path: '/visit/info', query: { companyName: data } })
}
/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await CustomerInfoApi.deleteCustomerInfo(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await CustomerInfoApi.exportCustomerInfo(queryParams)
    download.excel(data, '客户信息.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
